
//=========================================
// return definitions
#define OK						0	//No Error
#define ERROR_HEAP				-1 	//malloc() or free() return error
#define ERROR_NOINIT_INVALID	-2 	//No initital invalid check
#define ERROR_ERASE_NOT_REPLACED	-3 	//Erase block error, but it try to replace a new one, but failed
#define ERROR_WRITE_NOT_REPLACED	-4 	//Write page error, but it try to replace a new one, but failed
#define ERROR_READ_2BITERROR	-5 	//more than 2-bit error when read, it is not corrected by ECC
#define ERROR_WRITE_COPY_BACK	-6 	//Write copy back error
#define ERROR_RESERVED_OVERFLOW	-7 	//Write copy back error
#define WARNING_ERASE_REPLACED	1 	//Erase block error, but it has been replaced by a new one
#define WARNING_WRITE_REPLACED	2 	//Write page error, but it has been replaced by a new one, and copy all pages in that block to the new one
#define WARNING_READ_1BITERROR	3 	//1-bit error when read, it is corrected by ECC


//=========================================
// gblobal variables extern
//!block mapping table
extern unsigned int *ftable;
//!total block number of flash
extern unsigned int tblock;	

//=========================================
// function prototypes
//!before using flash APIs, you need init_flash()
int init_flash();		
//!when you no longer use flash APIs, you need close_flash() to release some system resource.
int close_flash();
int flash_block_erase(unsigned int page_in);
int flash_page_read(unsigned int page_in, unsigned char *dataout);
int flash_page_write(unsigned int page_in, unsigned char *datain);
unsigned int flash_id_read();
unsigned int flash_status_read();
void flash_reset();

